[Date Prev][Date Next] [Thread Prev][Thread Next] [Date Index] [Thread Index]

NMU for debootstrap (1.0.93+nmu2)



Hi,

 I've prepared next NMU for debootstrap package. I'll put it to repository
 after previous NMU reached to testing. Please check attached patches and
 below changelog.


----------------------------------------------------------------------------
debootstrap (1.0.93+nmu2) unstable; urgency=medium

  * Non-maintainer Upload.

  [ Hideki Yamane ]
  * Avoid pre-exist directory causes failure (Closes: #864734)
  * Split common code from scripts/sid to scripts/debian-common and share it
    between distributions (Closes: #798562)

  [ Lubomir Rintel ]
  * Don't let host PATH leak into the target commands. It works on chroots
    that have different PATH like Arch Linux and Fedora (Closes: #718632,
    #770658, #890418)

 -- Hideki Yamane <henrich@debian.org>  Wed, 07 Mar 2018 16:40:07 +0900
>From e6a2a63f5f5a191feb21fac4a7294d789dd6fb51 Mon Sep 17 00:00:00 2001
From: Hideki Yamane <h-yamane@m3.com>
Date: Wed, 7 Mar 2018 16:58:45 +0900
Subject: [PATCH 4/4] note to fix Bug#864734, #798562, #718632, #770658,
 #890418

---
 debian/changelog | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

diff --git a/debian/changelog b/debian/changelog
index 7421862..6360d80 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,3 +1,19 @@
+debootstrap (1.0.93+nmu2) unstable; urgency=medium
+
+  * Non-maintainer Upload.
+
+  [ Hideki Yamane ]
+  * Avoid pre-exist directory causes failure (Closes: #864734)
+  * Split common code from scripts/sid to scripts/debian-common and share it
+    between distributions (Closes: #798562)
+
+  [ Lubomir Rintel ]
+  * Don't let host PATH leak into the target commands. It works on chroots
+    that have different PATH like Arch Linux and Fedora (Closes: #718632,
+    #770658, #890418)
+
+ -- Hideki Yamane <henrich@debian.org>  Wed, 07 Mar 2018 16:40:07 +0900
+
 debootstrap (1.0.93+nmu1) unstable; urgency=medium
 
   * Non-maintainer Upload.
-- 
2.16.2

>From 829221eaeb38e517a2fdcef39fcd4fc202409316 Mon Sep 17 00:00:00 2001
From: Hideki Yamane <h-yamane@m3.com>
Date: Wed, 7 Mar 2018 16:56:30 +0900
Subject: [PATCH 3/4] Split common code from scripts/sid to
 scripts/debian-common and share it

fix Bug#798562
---
 scripts/debian-common | 208 +++++++++++++++++++++++++++++++++++++++++++++++++
 scripts/etch          | 210 +-------------------------------------------------
 scripts/sid           | 210 +-------------------------------------------------
 3 files changed, 212 insertions(+), 416 deletions(-)
 create mode 100644 scripts/debian-common

diff --git a/scripts/debian-common b/scripts/debian-common
new file mode 100644
index 0000000..36989a2
--- /dev/null
+++ b/scripts/debian-common
@@ -0,0 +1,208 @@
+if doing_variant fakechroot; then
+	test "$FAKECHROOT" = "true" || error 1 FAKECHROOTREQ "This variant requires fakechroot environment to be started"
+fi
+
+case $ARCH in
+	alpha|ia64) LIBC="libc6.1" ;;
+	kfreebsd-*) LIBC="libc0.1" ;;
+	hurd-*)     LIBC="libc0.3" ;;
+	*)          LIBC="libc6" ;;
+esac
+
+work_out_debs () {
+	required="$(get_debs Priority: required)"
+
+	if doing_variant - || doing_variant fakechroot; then
+		#required="$required $(get_debs Priority: important)"
+		#  ^^ should be getting debconf here somehow maybe
+		base="$(get_debs Priority: important)"
+	elif doing_variant buildd; then
+		base="apt build-essential"
+	elif doing_variant minbase; then
+		base="apt"
+	fi
+
+	if doing_variant fakechroot; then
+		# ldd.fake needs binutils
+		required="$required binutils"
+	fi
+
+	case $MIRRORS in
+	    https://*)
+		base="$base apt-transport-https ca-certificates"
+		;;
+	esac
+}
+
+first_stage_install () {
+	case "$CODENAME" in
+		etch|etch-m68k|jessie|jessie-kfreebsd|lenny|squeeze|wheezy) ;;
+		*)
+			EXTRACT_DEB_TAR_OPTIONS="$EXTRACT_DEB_TAR_OPTIONS -k"
+			setup_merged_usr
+			;;
+	esac
+
+	extract $required
+
+	mkdir -p "$TARGET/var/lib/dpkg"
+	: >"$TARGET/var/lib/dpkg/status"
+	: >"$TARGET/var/lib/dpkg/available"
+
+	setup_etc
+	if [ ! -e "$TARGET/etc/fstab" ]; then
+		echo '# UNCONFIGURED FSTAB FOR BASE SYSTEM' > "$TARGET/etc/fstab"
+		chown 0:0 "$TARGET/etc/fstab"; chmod 644 "$TARGET/etc/fstab"
+	fi
+
+	setup_devices
+}
+
+second_stage_install () {
+	setup_dynamic_devices
+
+	x_feign_install () {
+		local pkg="$1"
+		local deb="$(debfor $pkg)"
+		local ver="$(in_target dpkg-deb -f "$deb" Version)"
+
+		mkdir -p "$TARGET/var/lib/dpkg/info"
+
+		echo \
+"Package: $pkg
+Version: $ver
+Maintainer: unknown
+Status: install ok installed" >> "$TARGET/var/lib/dpkg/status"
+
+		touch "$TARGET/var/lib/dpkg/info/${pkg}.list"
+	}
+
+	x_feign_install dpkg
+
+	x_core_install () {
+		smallyes '' | in_target dpkg --force-depends --install $(debfor "$@")
+	}
+
+	p () {
+		baseprog="$(($baseprog + ${1:-1}))"
+	}
+
+	if doing_variant fakechroot; then
+		setup_proc_fakechroot
+	else
+		setup_proc
+		in_target /sbin/ldconfig
+	fi
+
+	DEBIAN_FRONTEND=noninteractive
+	DEBCONF_NONINTERACTIVE_SEEN=true
+	export DEBIAN_FRONTEND DEBCONF_NONINTERACTIVE_SEEN
+
+	baseprog=0
+	bases=7
+
+	p; progress $baseprog $bases INSTCORE "Installing core packages" #1
+	info INSTCORE "Installing core packages..."
+
+	p; progress $baseprog $bases INSTCORE "Installing core packages" #2
+	ln -sf mawk "$TARGET/usr/bin/awk"
+	x_core_install base-passwd
+	x_core_install base-files
+	p; progress $baseprog $bases INSTCORE "Installing core packages" #3
+	x_core_install dpkg
+
+	if [ ! -e "$TARGET/etc/localtime" ]; then
+		ln -sf /usr/share/zoneinfo/UTC "$TARGET/etc/localtime"
+	fi
+
+	if doing_variant fakechroot; then
+		install_fakechroot_tools
+	fi
+
+	p; progress $baseprog $bases INSTCORE "Installing core packages" #4
+	x_core_install $LIBC
+
+	p; progress $baseprog $bases INSTCORE "Installing core packages" #5
+	x_core_install perl-base
+
+	p; progress $baseprog $bases INSTCORE "Installing core packages" #6
+	rm "$TARGET/usr/bin/awk"
+	x_core_install mawk
+
+	p; progress $baseprog $bases INSTCORE "Installing core packages" #7
+	if doing_variant -; then
+		x_core_install debconf
+	fi
+
+	baseprog=0
+	bases=$(set -- $required; echo $#)
+
+	info UNPACKREQ "Unpacking required packages..."
+
+	exec 7>&1
+
+	smallyes '' |
+		(repeatn 5 in_target_failmsg UNPACK_REQ_FAIL_FIVE "Failure while unpacking required packages.  This will be attempted up to five times." "" \
+		dpkg --status-fd 8 --force-depends --unpack $(debfor $required) 8>&1 1>&7 || echo EXITCODE $?) |
+		dpkg_progress $baseprog $bases UNPACKREQ "Unpacking required packages" UNPACKING
+
+	info CONFREQ "Configuring required packages..."
+
+	echo \
+"#!/bin/sh
+exit 101" > "$TARGET/usr/sbin/policy-rc.d"
+	chmod 755 "$TARGET/usr/sbin/policy-rc.d"
+
+	mv "$TARGET/sbin/start-stop-daemon" "$TARGET/sbin/start-stop-daemon.REAL"
+	echo \
+"#!/bin/sh
+echo
+echo \"Warning: Fake start-stop-daemon called, doing nothing\"" > "$TARGET/sbin/start-stop-daemon"
+	chmod 755 "$TARGET/sbin/start-stop-daemon"
+
+	setup_dselect_method apt
+
+	smallyes '' |
+		(in_target_failmsg CONF_REQ_FAIL "Failure while configuring required packages." "" \
+		dpkg --status-fd 8 --configure --pending --force-configure-any --force-depends 8>&1 1>&7 || echo EXITCODE $?) |
+		dpkg_progress $baseprog $bases CONFREQ "Configuring required packages" CONFIGURING
+
+	baseprog=0
+	bases="$(set -- $base; echo $#)"
+
+	info UNPACKBASE "Unpacking the base system..."
+
+	setup_available $required $base
+	done_predeps=
+	while predep=$(get_next_predep); do
+		# We have to resolve dependencies of pre-dependencies manually because
+		# dpkg --predep-package doesn't handle this.
+		predep=$(without "$(without "$(resolve_deps $predep)" "$required")" "$done_predeps")
+		# XXX: progress is tricky due to how dpkg_progress works
+		# -- cjwatson 2009-07-29
+		p; smallyes '' |
+		in_target dpkg --force-overwrite --force-confold --skip-same-version --install $(debfor $predep)
+		base=$(without "$base" "$predep")
+		done_predeps="$done_predeps $predep"
+	done
+
+	if [ -n "$base" ]; then
+		smallyes '' |
+			(repeatn 5 in_target_failmsg INST_BASE_FAIL_FIVE "Failure while installing base packages.  This will be re-attempted up to five times." "" \
+			dpkg --status-fd 8 --force-overwrite --force-confold --skip-same-version --unpack $(debfor $base) 8>&1 1>&7 || echo EXITCODE $?) |
+			dpkg_progress $baseprog $bases UNPACKBASE "Unpacking base system" UNPACKING
+
+		info CONFBASE "Configuring the base system..."
+
+		smallyes '' |
+			(repeatn 5 in_target_failmsg CONF_BASE_FAIL_FIVE "Failure while configuring base packages.  This will be re-attempted up to five times." "" \
+			dpkg --status-fd 8 --force-confold --skip-same-version --configure -a 8>&1 1>&7 || echo EXITCODE $?) |
+			dpkg_progress $baseprog $bases CONFBASE "Configuring base system" CONFIGURING
+	fi
+
+	mv "$TARGET/sbin/start-stop-daemon.REAL" "$TARGET/sbin/start-stop-daemon"
+	rm -f "$TARGET/usr/sbin/policy-rc.d"
+
+	progress $bases $bases CONFBASE "Configuring base system"
+	info BASESUCCESS "Base system installed successfully."
+}
diff --git a/scripts/etch b/scripts/etch
index 22c89a9..9e4c63a 100644
--- a/scripts/etch
+++ b/scripts/etch
@@ -6,211 +6,5 @@ default_mirror http://archive.debian.org/debian
 keyring /usr/share/keyrings/debian-archive-removed-keys.gpg
 force_md5
 
-if doing_variant fakechroot; then
-	test "$FAKECHROOT" = "true" || error 1 FAKECHROOTREQ "This variant requires fakechroot environment to be started"
-fi
-
-case $ARCH in
-	alpha|ia64) LIBC="libc6.1" ;;
-	kfreebsd-*) LIBC="libc0.1" ;;
-	hurd-*)     LIBC="libc0.3" ;;
-	*)          LIBC="libc6" ;;
-esac
-
-work_out_debs () {
-	required="$(get_debs Priority: required)"
-
-	if doing_variant - || doing_variant fakechroot; then
-		#required="$required $(get_debs Priority: important)"
-		#  ^^ should be getting debconf here somehow maybe
-		base="$(get_debs Priority: important)"
-	elif doing_variant buildd; then
-		base="apt build-essential"
-	elif doing_variant minbase; then
-		base="apt"
-	fi
-
-	if doing_variant fakechroot; then
-		# ldd.fake needs binutils
-		required="$required binutils"
-	fi
-
-	case $MIRRORS in
-	    https://*)
-		base="$base apt-transport-https ca-certificates"
-		;;
-	esac
-}
-
-first_stage_install () {
-	case "$CODENAME" in
-		etch|etch-m68k|jessie|jessie-kfreebsd|lenny|squeeze|wheezy) ;;
-		*)
-			EXTRACT_DEB_TAR_OPTIONS="$EXTRACT_DEB_TAR_OPTIONS -k"
-			setup_merged_usr
-			;;
-	esac
-
-	extract $required
-
-	mkdir -p "$TARGET/var/lib/dpkg"
-	: >"$TARGET/var/lib/dpkg/status"
-	: >"$TARGET/var/lib/dpkg/available"
-
-	setup_etc
-	if [ ! -e "$TARGET/etc/fstab" ]; then
-		echo '# UNCONFIGURED FSTAB FOR BASE SYSTEM' > "$TARGET/etc/fstab"
-		chown 0:0 "$TARGET/etc/fstab"; chmod 644 "$TARGET/etc/fstab"
-	fi
-
-	setup_devices
-}
-
-second_stage_install () {
-	setup_dynamic_devices
-
-	x_feign_install () {
-		local pkg="$1"
-		local deb="$(debfor $pkg)"
-		local ver="$(in_target dpkg-deb -f "$deb" Version)"
-
-		mkdir -p "$TARGET/var/lib/dpkg/info"
-
-		echo \
-"Package: $pkg
-Version: $ver
-Maintainer: unknown
-Status: install ok installed" >> "$TARGET/var/lib/dpkg/status"
-
-		touch "$TARGET/var/lib/dpkg/info/${pkg}.list"
-	}
-
-	x_feign_install dpkg
-
-	x_core_install () {
-		smallyes '' | in_target dpkg --force-depends --install $(debfor "$@")
-	}
-
-	p () {
-		baseprog="$(($baseprog + ${1:-1}))"
-	}
-
-	if doing_variant fakechroot; then
-		setup_proc_fakechroot
-	else
-		setup_proc
-		in_target /sbin/ldconfig
-	fi
-
-	DEBIAN_FRONTEND=noninteractive
-	DEBCONF_NONINTERACTIVE_SEEN=true
-	export DEBIAN_FRONTEND DEBCONF_NONINTERACTIVE_SEEN
-
-	baseprog=0
-	bases=7
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #1
-	info INSTCORE "Installing core packages..."
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #2
-	ln -sf mawk "$TARGET/usr/bin/awk"
-	x_core_install base-passwd
-	x_core_install base-files
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #3
-	x_core_install dpkg
-
-	if [ ! -e "$TARGET/etc/localtime" ]; then
-		ln -sf /usr/share/zoneinfo/UTC "$TARGET/etc/localtime"
-	fi
-
-	if doing_variant fakechroot; then
-		install_fakechroot_tools
-	fi
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #4
-	x_core_install $LIBC
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #5
-	x_core_install perl-base
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #6
-	rm "$TARGET/usr/bin/awk"
-	x_core_install mawk
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #7
-	if doing_variant -; then
-		x_core_install debconf
-	fi
-
-	baseprog=0
-	bases=$(set -- $required; echo $#)
-
-	info UNPACKREQ "Unpacking required packages..."
-
-	exec 7>&1
-
-	smallyes '' |
-		(repeatn 5 in_target_failmsg UNPACK_REQ_FAIL_FIVE "Failure while unpacking required packages.  This will be attempted up to five times." "" \
-		dpkg --status-fd 8 --force-depends --unpack $(debfor $required) 8>&1 1>&7 || echo EXITCODE $?) |
-		dpkg_progress $baseprog $bases UNPACKREQ "Unpacking required packages" UNPACKING
-
-	info CONFREQ "Configuring required packages..."
-
-	echo \
-"#!/bin/sh
-exit 101" > "$TARGET/usr/sbin/policy-rc.d"
-	chmod 755 "$TARGET/usr/sbin/policy-rc.d"
-
-	mv "$TARGET/sbin/start-stop-daemon" "$TARGET/sbin/start-stop-daemon.REAL"
-	echo \
-"#!/bin/sh
-echo
-echo \"Warning: Fake start-stop-daemon called, doing nothing\"" > "$TARGET/sbin/start-stop-daemon"
-	chmod 755 "$TARGET/sbin/start-stop-daemon"
-
-	setup_dselect_method apt
-
-	smallyes '' |
-		(in_target_failmsg CONF_REQ_FAIL "Failure while configuring required packages." "" \
-		dpkg --status-fd 8 --configure --pending --force-configure-any --force-depends 8>&1 1>&7 || echo EXITCODE $?) |
-		dpkg_progress $baseprog $bases CONFREQ "Configuring required packages" CONFIGURING
-
-	baseprog=0
-	bases="$(set -- $base; echo $#)"
-
-	info UNPACKBASE "Unpacking the base system..."
-
-	setup_available $required $base
-	done_predeps=
-	while predep=$(get_next_predep); do
-		# We have to resolve dependencies of pre-dependencies manually because
-		# dpkg --predep-package doesn't handle this.
-		predep=$(without "$(without "$(resolve_deps $predep)" "$required")" "$done_predeps")
-		# XXX: progress is tricky due to how dpkg_progress works
-		# -- cjwatson 2009-07-29
-		p; smallyes '' |
-		in_target dpkg --force-overwrite --force-confold --skip-same-version --install $(debfor $predep)
-		base=$(without "$base" "$predep")
-		done_predeps="$done_predeps $predep"
-	done
-
-	if [ -n "$base" ]; then
-		smallyes '' |
-			(repeatn 5 in_target_failmsg INST_BASE_FAIL_FIVE "Failure while installing base packages.  This will be re-attempted up to five times." "" \
-			dpkg --status-fd 8 --force-overwrite --force-confold --skip-same-version --unpack $(debfor $base) 8>&1 1>&7 || echo EXITCODE $?) |
-			dpkg_progress $baseprog $bases UNPACKBASE "Unpacking base system" UNPACKING
-
-		info CONFBASE "Configuring the base system..."
-
-		smallyes '' |
-			(repeatn 5 in_target_failmsg CONF_BASE_FAIL_FIVE "Failure while configuring base packages.  This will be re-attempted up to five times." "" \
-			dpkg --status-fd 8 --force-confold --skip-same-version --configure -a 8>&1 1>&7 || echo EXITCODE $?) |
-			dpkg_progress $baseprog $bases CONFBASE "Configuring base system" CONFIGURING
-	fi
-
-	mv "$TARGET/sbin/start-stop-daemon.REAL" "$TARGET/sbin/start-stop-daemon"
-	rm -f "$TARGET/usr/sbin/policy-rc.d"
-
-	progress $bases $bases CONFBASE "Configuring base system"
-	info BASESUCCESS "Base system installed successfully."
-}
+# include common settings
+ . /usr/share/debootstrap/scripts/debian-common
diff --git a/scripts/sid b/scripts/sid
index 1d96477..885d01e 100644
--- a/scripts/sid
+++ b/scripts/sid
@@ -4,211 +4,5 @@ finddebs_style from-indices
 variants - buildd fakechroot minbase
 keyring /usr/share/keyrings/debian-archive-keyring.gpg
 
-if doing_variant fakechroot; then
-	test "$FAKECHROOT" = "true" || error 1 FAKECHROOTREQ "This variant requires fakechroot environment to be started"
-fi
-
-case $ARCH in
-	alpha|ia64) LIBC="libc6.1" ;;
-	kfreebsd-*) LIBC="libc0.1" ;;
-	hurd-*)     LIBC="libc0.3" ;;
-	*)          LIBC="libc6" ;;
-esac
-
-work_out_debs () {
-	required="$(get_debs Priority: required)"
-
-	if doing_variant - || doing_variant fakechroot; then
-		#required="$required $(get_debs Priority: important)"
-		#  ^^ should be getting debconf here somehow maybe
-		base="$(get_debs Priority: important)"
-	elif doing_variant buildd; then
-		base="apt build-essential"
-	elif doing_variant minbase; then
-		base="apt"
-	fi
-
-	if doing_variant fakechroot; then
-		# ldd.fake needs binutils
-		required="$required binutils"
-	fi
-
-	case $MIRRORS in
-	    https://*)
-		base="$base apt-transport-https ca-certificates"
-		;;
-	esac
-}
-
-first_stage_install () {
-	case "$CODENAME" in
-		etch|etch-m68k|jessie|jessie-kfreebsd|lenny|squeeze|wheezy) ;;
-		*)
-			EXTRACT_DEB_TAR_OPTIONS="$EXTRACT_DEB_TAR_OPTIONS -k"
-			setup_merged_usr
-			;;
-	esac
-
-	extract $required
-
-	mkdir -p "$TARGET/var/lib/dpkg"
-	: >"$TARGET/var/lib/dpkg/status"
-	: >"$TARGET/var/lib/dpkg/available"
-
-	setup_etc
-	if [ ! -e "$TARGET/etc/fstab" ]; then
-		echo '# UNCONFIGURED FSTAB FOR BASE SYSTEM' > "$TARGET/etc/fstab"
-		chown 0:0 "$TARGET/etc/fstab"; chmod 644 "$TARGET/etc/fstab"
-	fi
-
-	setup_devices
-}
-
-second_stage_install () {
-	setup_dynamic_devices
-
-	x_feign_install () {
-		local pkg="$1"
-		local deb="$(debfor $pkg)"
-		local ver="$(in_target dpkg-deb -f "$deb" Version)"
-
-		mkdir -p "$TARGET/var/lib/dpkg/info"
-
-		echo \
-"Package: $pkg
-Version: $ver
-Maintainer: unknown
-Status: install ok installed" >> "$TARGET/var/lib/dpkg/status"
-
-		touch "$TARGET/var/lib/dpkg/info/${pkg}.list"
-	}
-
-	x_feign_install dpkg
-
-	x_core_install () {
-		smallyes '' | in_target dpkg --force-depends --install $(debfor "$@")
-	}
-
-	p () {
-		baseprog="$(($baseprog + ${1:-1}))"
-	}
-
-	if doing_variant fakechroot; then
-		setup_proc_fakechroot
-	else
-		setup_proc
-		in_target /sbin/ldconfig
-	fi
-
-	DEBIAN_FRONTEND=noninteractive
-	DEBCONF_NONINTERACTIVE_SEEN=true
-	export DEBIAN_FRONTEND DEBCONF_NONINTERACTIVE_SEEN
-
-	baseprog=0
-	bases=7
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #1
-	info INSTCORE "Installing core packages..."
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #2
-	ln -sf mawk "$TARGET/usr/bin/awk"
-	x_core_install base-passwd
-	x_core_install base-files
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #3
-	x_core_install dpkg
-
-	if [ ! -e "$TARGET/etc/localtime" ]; then
-		ln -sf /usr/share/zoneinfo/UTC "$TARGET/etc/localtime"
-	fi
-
-	if doing_variant fakechroot; then
-		install_fakechroot_tools
-	fi
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #4
-	x_core_install $LIBC
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #5
-	x_core_install perl-base
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #6
-	rm "$TARGET/usr/bin/awk"
-	x_core_install mawk
-
-	p; progress $baseprog $bases INSTCORE "Installing core packages" #7
-	if doing_variant -; then
-		x_core_install debconf
-	fi
-
-	baseprog=0
-	bases=$(set -- $required; echo $#)
-
-	info UNPACKREQ "Unpacking required packages..."
-
-	exec 7>&1
-
-	smallyes '' |
-		(repeatn 5 in_target_failmsg UNPACK_REQ_FAIL_FIVE "Failure while unpacking required packages.  This will be attempted up to five times." "" \
-		dpkg --status-fd 8 --force-depends --unpack $(debfor $required) 8>&1 1>&7 || echo EXITCODE $?) |
-		dpkg_progress $baseprog $bases UNPACKREQ "Unpacking required packages" UNPACKING
-
-	info CONFREQ "Configuring required packages..."
-
-	echo \
-"#!/bin/sh
-exit 101" > "$TARGET/usr/sbin/policy-rc.d"
-	chmod 755 "$TARGET/usr/sbin/policy-rc.d"
-
-	mv "$TARGET/sbin/start-stop-daemon" "$TARGET/sbin/start-stop-daemon.REAL"
-	echo \
-"#!/bin/sh
-echo
-echo \"Warning: Fake start-stop-daemon called, doing nothing\"" > "$TARGET/sbin/start-stop-daemon"
-	chmod 755 "$TARGET/sbin/start-stop-daemon"
-
-	setup_dselect_method apt
-
-	smallyes '' |
-		(in_target_failmsg CONF_REQ_FAIL "Failure while configuring required packages." "" \
-		dpkg --status-fd 8 --configure --pending --force-configure-any --force-depends 8>&1 1>&7 || echo EXITCODE $?) |
-		dpkg_progress $baseprog $bases CONFREQ "Configuring required packages" CONFIGURING
-
-	baseprog=0
-	bases="$(set -- $base; echo $#)"
-
-	info UNPACKBASE "Unpacking the base system..."
-
-	setup_available $required $base
-	done_predeps=
-	while predep=$(get_next_predep); do
-		# We have to resolve dependencies of pre-dependencies manually because
-		# dpkg --predep-package doesn't handle this.
-		predep=$(without "$(without "$(resolve_deps $predep)" "$required")" "$done_predeps")
-		# XXX: progress is tricky due to how dpkg_progress works
-		# -- cjwatson 2009-07-29
-		p; smallyes '' |
-		in_target dpkg --force-overwrite --force-confold --skip-same-version --install $(debfor $predep)
-		base=$(without "$base" "$predep")
-		done_predeps="$done_predeps $predep"
-	done
-
-	if [ -n "$base" ]; then
-		smallyes '' |
-			(repeatn 5 in_target_failmsg INST_BASE_FAIL_FIVE "Failure while installing base packages.  This will be re-attempted up to five times." "" \
-			dpkg --status-fd 8 --force-overwrite --force-confold --skip-same-version --unpack $(debfor $base) 8>&1 1>&7 || echo EXITCODE $?) |
-			dpkg_progress $baseprog $bases UNPACKBASE "Unpacking base system" UNPACKING
-
-		info CONFBASE "Configuring the base system..."
-
-		smallyes '' |
-			(repeatn 5 in_target_failmsg CONF_BASE_FAIL_FIVE "Failure while configuring base packages.  This will be re-attempted up to five times." "" \
-			dpkg --status-fd 8 --force-confold --skip-same-version --configure -a 8>&1 1>&7 || echo EXITCODE $?) |
-			dpkg_progress $baseprog $bases CONFBASE "Configuring base system" CONFIGURING
-	fi
-
-	mv "$TARGET/sbin/start-stop-daemon.REAL" "$TARGET/sbin/start-stop-daemon"
-	rm -f "$TARGET/usr/sbin/policy-rc.d"
-
-	progress $bases $bases CONFBASE "Configuring base system"
-	info BASESUCCESS "Base system installed successfully."
-}
+# include common settings
+ . /usr/share/debootstrap/scripts/debian-common
-- 
2.16.2

>From b66e21a6f071c469b31fb1dfc32876173f5b11c1 Mon Sep 17 00:00:00 2001
From: Lubomir Rintel <lkundrak@v3.sk>
Date: Sat, 27 Jan 2018 11:04:11 +0100
Subject: [PATCH 2/4] Don't let host PATH leak into the target commands

This fixes debootstrap on Fedora host, with unified /usr and PATH
lacking /bin and /sbin.
---
 functions | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/functions b/functions
index 43969ee..b780488 100644
--- a/functions
+++ b/functions
@@ -976,7 +976,7 @@ extract () { (
 ); }
 
 in_target_nofail () {
-	if ! $CHROOT_CMD "$@" 2>/dev/null; then
+	if ! PATH=/sbin:/usr/sbin:/bin:/usr/bin $CHROOT_CMD "$@" 2>/dev/null; then
 		true
 	fi
 	return 0
@@ -987,7 +987,7 @@ in_target_failmsg () {
 	local msg="$2"
 	local arg="$3"
 	shift; shift; shift
-	if ! $CHROOT_CMD "$@"; then
+	if ! PATH=/sbin:/usr/sbin:/bin:/usr/bin $CHROOT_CMD "$@"; then
 		warning "$code" "$msg" "$arg"
 		# Try to point user at actual failing package.
 		msg="See %s for details"
-- 
2.16.2

>From abd372951fb24fcbcba8d99b6ffc40f96ca37958 Mon Sep 17 00:00:00 2001
From: Hideki Yamane <h-yamane@m3.com>
Date: Wed, 7 Mar 2018 16:32:39 +0900
Subject: [PATCH 1/4] Avoid pre-exist directory causes failure (Bug#864734)

---
 functions | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/functions b/functions
index 3cfa0d4..43969ee 100644
--- a/functions
+++ b/functions
@@ -1170,7 +1170,8 @@ setup_devices_simple () {
 	mknod -m 666 $TARGET/dev/random	c 1 8
 	mknod -m 666 $TARGET/dev/urandom	c 1 9
 	mknod -m 666 $TARGET/dev/tty	c 5 0
-	mkdir $TARGET/dev/pts/ $TARGET/dev/shm/
+	# To avoid pre-exist directory causes error, specify "-p" option
+	mkdir -p $TARGET/dev/pts/ $TARGET/dev/shm/
 	# Inside a container, we might not be allowed to create /dev/ptmx.
 	# If not, do the next best thing.
 	if ! mknod -m 666 $TARGET/dev/ptmx c 5 2; then
-- 
2.16.2


Reply to: